qr_admin/urls.py
from django.urls import path, re_path
from django.contrib.auth import views as auth_views

from . import views

app_name = 'qr_admin'

urlpatterns = [
    re_path(r'^$', auth_views.LoginView.as_view(template_name= 'login.html'), name='login'),
    re_path(r'^logout/$', auth_views.LogoutView.as_view(next_page= '/qr_admin'), name='logout'),
    re_path(r'^tables/', views.tables, name = 'tables'),
    re_path(r'^summary/', views.summary, name = 'summary'),
    re_path(r'^qrCodeReader/', views.qr_code_reader, name = 'qrCodeReader'),
    re_path(r'^uploadData/', views.upload_data, name = 'uploadData'),
    re_path(r'^uploadExcel/', views.upload_excel, name = 'uploadExcel'),
    re_path(r'^validate/', views.validate, name = 'validate'),
    re_path(r'^flag/', views.flag, name = 'flag'),
    re_path(r'^generateQR/', views.generate_qr_image, name = 'generateQR'),
]

qrscanner/urls.py
from django.contrib import admin
from django.views.generic.base import RedirectView
from django.urls import include, path, re_path
import qr_admin.urls as qr_admin

urlpatterns = [
    re_path(r'^$', RedirectView.as_view(url='qr_admin/', permanent = True), name='$'),
    path('admin/', admin.site.urls),
    path('qr_admin/', include('qr_admin.urls')),
]

qr_admin/models.py
from django.db import models

class Order(models.Model):
    order_id = models.CharField(max_length=10, primary_key=True)
    ticket_count = models.IntegerField()
    name = models.CharField(max_length=50, blank=True)
    email = models.CharField(max_length=50, blank=True)
    phone = models.CharField(max_length=20, blank=True)

class Ticket(models.Model):
    order = models.ForeignKey(Order, on_delete=models.CASCADE)
    ticket_id = models.CharField(max_length=13, primary_key=True)
    redeemed = models.BooleanField(default=False)
    updated_at = models.DateTimeField(auto_now=True)

class ExcelFileUpload(models.Model):
    excel_file = models.FileField(upload_to='static/excel')

qr_admin/views.py
from django.contrib.auth.decorators import login_required
from django.shortcuts import render
from django.http import HttpResponse, JsonResponse
from django.views.decorators.csrf import csrf_exempt
from django.conf import settings

from .models import Ticket, ExcelFileUpload
from .utils import generate_qr, parse_excel

import logging

response = {}

@login_required
def tables(request):
    tickets = Ticket.objects.all()
    response['tickets'] = tickets
    return render(request, 'dashboard.html', response)

@login_required
def summary(request):
    ticket_count = Ticket.objects.all().count()
    redeemed_ticket = Ticket.objects.filter(redeemed=True).count()
    response['ticket_count'] = ticket_count
    response['redeemed_ticket'] = redeemed_ticket
    return render(request, 'summary.html', response)

@login_required
def qr_code_reader(request):
    return render(request, 'qrcodereader.html', response)

@login_required
def upload_data(request):
    return render(request, 'uploadData.html', response)

@login_required
def upload_excel(request):
    try:
        if request.method == 'POST' and request.FILES['myFile']:
            parse_excel(request.FILES['myFile'])
    except Exception:
        logging.exception('An exception was thrown!')
    return render(request, 'uploadData.html', response)

@login_required
@csrf_exempt
def validate(request):
    ticket_id = request.POST.get("ticketId")
    exists = Ticket.objects.filter(ticket_id__iexact=ticket_id).exists()
    data = {
        'exists': exists
    }
    return JsonResponse(data)

@login_required
@csrf_exempt
def flag(request):
    if request.method == 'POST':
        ticket_id = request.POST.get('ticketId')
        ticket = Ticket.objects.get(ticket_id=ticket_id)
        data = {
            'redeemed': ticket.redeemed
        }
        if ticket.redeemed:
            return JsonResponse(data)
        ticket.redeemed = True
        ticket.save()
        return JsonResponse(data)

def generate_qr_image(request):
    generate_qr('1201710728002', f'{settings.BASE_DIR}/static/ticket.jpg')
    return JsonResponse({})
    

templates/dashboard.html
{% extends "navbarAdmin.html" %}
{% load static %}
{% block content %}
<div class="card mb-3">
  <div class="card-header">
    <i class="fa fa-table"></i> Dashboard
  </div>
  <div class="card-body">
    <div><button id="refresh" onclick="refreshTable()"><i class="fa fa-refresh"></i> Refresh</button></div>
    <hr>
    <div class="table-responsive">
      <table class="table table-bordered" id="ticketTable" width="100%" cellspacing="0">
        <thead>
          <tr>
            <th>Ticket Id</th>
            <th>Order Id</th>
            <th>Name</th>
            <th>Email</th>
            <th>Phone</th>
            <th>Is Redeemed</th>
            <th>Redeem Time</th>
          </tr>
        </thead>
        <tfoot>
          <tr>
            <th>Ticket Id</th>
            <th>Order Id</th>
            <th>Name</th>
            <th>Email</th>
            <th>Phone</th>
            <th>Is Redeemed</th>
            <th>Redeem Time</th>
          </tr>
        </tfoot>
        <tbody id="tableTicket">
          {% for ticket in tickets %}
          <tr>
            <td>{{ ticket.ticket_id }}</td>
            <td>{{ ticket.order.order_id }}</td>
            <td>{{ ticket.order.name }}</td>
            <td><a href="mailto:{{ ticket.order.email }}">{{ ticket.order.email }}</a></td>
            <td>{{ ticket.order.phone }}</td>
            <td>{{ ticket.redeemed }}</td>
            <td><span class='hide'>{{ ticket.updated_at|date:"YmdHis" }}</span>{{ ticket.updated_at }}</td>
          </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
  </div>
</div>
<script>
$(document).ready(function() {
  $('#ticketTable').DataTable({
    "order": [[ 6, "desc" ]]
  });
});

function refreshTable() {
  location.reload();
}
</script>
<style type="text/css">
  .btn-check {
    background-color: white;
    border: none;
    padding: 5px 5px;
    text-align: center;
    text-decoration: none;
    display: inline-block;
    font-size: 16px;
    border-radius: 8px;
  }

  .btn-check:hover {
    color: blue;
  }

  .btn-check-v {
    color: green;
  }

  .btn-check-x {
    color: red;
  }
</style>
{% endblock %}

templates/login.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>Admin</title>

    <!-- bootstrap csss -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-alpha.6/css/bootstrap.min.css" integrity="sha384-rwoIResjU2yc3z8GV/NPeZWAv56rSmLldC3R/AZzGRnGxQQKnKkoFVhFQhNUwEyJ" crossorigin="anonymous">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
    <style>
    	/*
 * Specific styles of signin component
 */
/*
 * General styles
 */

body, html {
    height: 100%;
    background-repeat: no-repeat;
}


.card-container.card {
    max-width: 350px;
    padding: 40px 40px;
}

.btn {
    font-weight: 700;
    height: 36px;
    -moz-user-select: none;
    -webkit-user-select: none;
    user-select: none;
    cursor: default;
}

/*
 * Card component
 */
.card {
    background-color: #F7F7F7;
    /* just in case there no content*/
    padding: 20px 25px 30px;
    margin: 0 auto 25px;
    margin-top: 50px;
    /* shadows and rounded borders */
    -moz-border-radius: 2px;
    -webkit-border-radius: 2px;
    border-radius: 2px;
    -moz-box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
    -webkit-box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
    box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
}

.profile-img-card {
    width: 96px;
    height: 96px;
    margin: 0 auto 10px;
    display: block;
    -moz-border-radius: 50%;
    -webkit-border-radius: 50%;
    border-radius: 50%;
}

/*
 * Form styles
 */
.profile-name-card {
    font-size: 16px;
    font-weight: bold;
    text-align: center;
    margin: 10px 0 0;
    min-height: 1em;
}

.reauth-email {
    display: block;
    color: #404040;
    line-height: 2;
    margin-bottom: 10px;
    font-size: 14px;
    text-align: center;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    -moz-box-sizing: border-box;
    -webkit-box-sizing: border-box;
    box-sizing: border-box;
}

.form-signin #inputEmail,
.form-signin #inputPassword {
    direction: ltr;
    height: 44px;
    font-size: 16px;
}

.form-signin input[type=email],
.form-signin input[type=password],
.form-signin input[type=text],
.form-signin button {
    width: 100%;
    display: block;
    margin-bottom: 10px;
    z-index: 1;
    position: relative;
    -moz-box-sizing: border-box;
    -webkit-box-sizing: border-box;
    box-sizing: border-box;
}

.form-signin .form-control:focus {
    border-color: rgb(104, 145, 162);
    outline: 0;
    -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075),0 0 8px rgb(104, 145, 162);
    box-shadow: inset 0 1px 1px rgba(0,0,0,.075),0 0 8px rgb(104, 145, 162);
}

.btn.btn-signin {
    /*background-color: #4d90fe; */
    background-color: rgb(104, 145, 162);
    /* background-color: linear-gradient(rgb(104, 145, 162), rgb(12, 97, 33));*/
    padding: 0px;
    font-weight: 700;
    font-size: 14px;
    height: 36px;
    -moz-border-radius: 3px;
    -webkit-border-radius: 3px;
    border-radius: 3px;
    border: none;
    -o-transition: all 0.218s;
    -moz-transition: all 0.218s;
    -webkit-transition: all 0.218s;
    transition: all 0.218s;
}

.btn.btn-signin:hover,
.btn.btn-signin:active,
.btn.btn-signin:focus {
    background-color: rgb(12, 97, 33);
}

.forgot-password {
    color: rgb(104, 145, 162);
}

.forgot-password:hover,
.forgot-password:active,
.forgot-password:focus{
    color: rgb(12, 97, 33);
}
    </style>
</head>

<body> 
	<div class="container">
        <div class="card card-container">
			<title>Admin</title>
			<b><h2>Qr Admin</h2></b>
			<form method="post">
				{% csrf_token %}
				{{ form.as_p }}
				<button class="btn btn-lg btn-primary btn-block btn-signin" type="submit">Login</button>
			</form>
		</div>
	</div>
</body>

templates/navbarAdmin.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="author" content="">
  <title>Admin</title>
  <!-- Bootstrap core CSS-->
  <link href="{% static 'vendor/bootstrap/css/bootstrap.min.css' %}" rel="stylesheet">
  <!-- Custom fonts for this template-->
  <link href="{% static 'vendor/font-awesome/css/font-awesome.min.css' %}" rel="stylesheet" type="text/css">
  <!-- Page level plugin CSS-->
  <link href="{% static 'vendor/datatables/dataTables.bootstrap4.css' %}" rel="stylesheet">
  <!-- Custom styles for this template-->
  <link href="{% static 'css/sb-admin.css' %}" rel="stylesheet">
  <link href="https://cdn.datatables.net/buttons/1.5.2/css/buttons.dataTables.min.css" rel="stylesheet" type="text/css">

  <script src="{% static 'vendor/jquery/jqueryAdmin.min.js' %}"></script>
</head>

<body class="fixed-nav sticky-footer bg-dark" id="page-top">
  <!-- Navigation-->
  <nav class="navbar navbar-expand-lg navbar-dark bg-dark fixed-top" id="mainNav">
    <a class="navbar-brand" href="#">Admin</a>
    <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarResponsive">
      <ul class="navbar-nav navbar-sidenav" id="exampleAccordion">
        <li class="nav-item" data-toggle="tooltip" data-placement="right" title="Tables">
          <a class="nav-link" href="/qr_admin/tables">
            <i class="fa fa-fw fa-table"></i>
            <span class="nav-link-text">Tables</span>
          </a>
          <li class="nav-item" data-toggle="tooltip" data-placement="right" title="Link">
            <a class="nav-link" href="/qr_admin/summary">
              <i class="fa fa-fw fa-table"></i>
              <span class="nav-link-text">Summary</span>
            </a>
          </li>
        </li>
        <li class="nav-item" data-toggle="tooltip" data-placement="right" title="Link">
          <a class="nav-link" href="/qr_admin/qrCodeReader">
            <i class="fa fa-fw fa-link"></i>
            <span class="nav-link-text">QR Code Reader</span>
          </a>
        </li>
        <li class="nav-item" data-toggle="tooltip" data-placement="right" title="Link">
          <a class="nav-link" href="/qr_admin/uploadData">
            <i class="fa fa-fw fa-link"></i>
            <span class="nav-link-text">Upload Data</span>
          </a>
        </li>
      </ul>
        <!-- <li class="nav-item" data-toggle="tooltip" data-placement="right" title="Components">
          <a class="nav-link nav-link-collapse collapsed" data-toggle="collapse" href="#collapseComponents" data-parent="#exampleAccordion">
            <i class="fa fa-fw fa-wrench"></i>
            <span class="nav-link-text">Edit Page</span>
          </a>
          <ul class="sidenav-second-level collapse" id="collapseComponents">
            <li>
              <a href="/tossaka_admin/acara">Acara</a>
            </li>
            <li>
              <a href="/tossaka_admin/editPageNilai">Peringkat Nilai</a>
            </li>
            <li>
              <a href="/tossaka_admin/uploadSponsor">Gambar Sponsor</a>
            </li>
            <li>
              <a href="/tossaka_admin/uploadMedpar">Gambar Media Partner</a>
            </li>
          </ul>
        </li>
      </ul> -->
      <ul class="navbar-nav sidenav-toggler">
        <li class="nav-item">
          <a class="nav-link text-center" id="sidenavToggler">
            <i class="fa fa-fw fa-angle-left"></i>
          </a>
        </li>
      </ul>
      <ul class="navbar-nav ml-auto">
        <li class="nav-item">
          <a class="nav-link" data-toggle="modal" data-target="#exampleModal">
            <i class="fa fa-fw fa-sign-out"></i>Logout</a>
        </li>
      </ul>
    </div>
  </nav>
  <div class="content-wrapper">
    <div class="container-fluid">
      <!-- content -->
      {% block content %}
      {% endblock %}  
    </div>
  </div>
    <!-- /.container-fluid-->
    <!-- /.content-wrapper-->
    <footer class="sticky-footer">
      <div class="container">
        <div class="text-center">
          <small>Copyright © Kemas</small>
        </div>
      </div>
    </footer>
    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
      <i class="fa fa-angle-up"></i>
    </a>
    <!-- Logout Modal-->
    <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Ready to Leave?</h5>
            <button class="close" type="button" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">×</span>
            </button>
          </div>
          <div class="modal-body">Select "Logout" below if you are ready to end your current session.</div>
          <div class="modal-footer">
            <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
            <a class="btn btn-primary" href="/qr_admin/logout">Logout</a>
          </div>
        </div>
      </div>
    </div>
    <!-- Bootstrap core JavaScript-->
    <!-- <script src="{% static 'vendor/jquery/jqueryAdmin.min.js' %}"></script> -->
    <script src="{% static 'vendor/bootstrap/js/bootstrap.bundle.min.js' %}"></script>
    <!-- Core plugin JavaScript-->
    <script src="{% static 'vendor/jquery-easing/jquery.easing.min.js' %}"></script>
    <!-- Page level plugin JavaScript-->
    <script src="{% static 'vendor/chart.js/Chart.min.js' %}"></script>
    <script src="{% static 'vendor/datatables/jquery.dataTables.js' %}"></script>
    <script src="{% static 'vendor/datatables/dataTables.bootstrap4.js' %}"></script>
    <!-- Custom scripts for all pages-->
    <script src="{% static 'js/admin/sb-admin.min.js' %}"></script>
    <!-- Custom scripts for this page-->
    <script src="{% static 'js/admin/sb-admin-datatables.min.js' %}"></script>
    <script src="{% static 'js/admin/sb-admin-charts.min.js' %}"></script>
  </div>
</body>
<style type="text/css">
  #qr {
    height: 450px;
    width: 600px;
  }

  @media screen and (max-width: 768px) {
    #qr {
    height: 225px;
    width: 300px;
    }
    }

  #refresh {
    background-color: white;
    border: 0.5px solid black;
    padding: 10px 20px;
    text-align: center;
    text-decoration: none;
    display: inline-block;
    font-size: 16px;
    border-radius: 8px;
  }

  #refresh:hover {
    background-color: black;
    color: white;
  }

</style>
<!-- <script>
  var paidSlide = function(id){
          console.log(id);
          $.ajax({
            method: "GET",
            url: "/tossaka_admin/paidSlide/"+id+"/",
        });
    }
</script> -->

</html>

templates/qrcodereader.html
{% extends "navbarAdmin.html" %}
{% load static %}
{% block content %}
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>QR Code Scanner</title>
</head>
<body>
	<div class="container" style="text-align: center">
		<h1> SCAN QR CODE </h1>

		<div class="row" style="margin-left: 10vw; margin-bottom: 2vw; margin-top: 10vw;">
			<button id="scan" class="btn btn-success btn-sm">start scaning</button>
			<button id="stop" class="btn btn-warning btn-sm disabled">stop scanning</button>
			<button id="change" class="btn btn-warning btn-sm disabled">change camera</button>
		</div>
		<div class="row" style="margin-bottom: 5vw;">
			<div class="col-md-12">
				<code>Start Scanning</code><br><span class="feedback"></span>
			</div>
		</div>

		<div id="qr" style="display: inline-block; border: 1px solid silver"></div>
	</div>
	<!-- <div class="card mb-3">
        <div class="card-header">
          <i class="fa fa-table"></i> Kedatangan</div>
        <div class="card-body">
         <div class="container-refresh">
          <button id="refresh" onclick="refreshTableArival()"><i class="fa fa-refresh"></i> Refresh</button></div>
          <hr>
          <div class="table-responsive">
            <table class="table table-bordered" id="aribaTable" width="100%" cellspacing="0">
              <thead>
                <tr>
                  <th>Nomor Peserta</th>
                  <th>Nama</th>
                  <th>Email</th>
                </tr>
              </thead>
              <tfoot>
                <tr>
                  <th>Nomor Peserta</th>
                  <th>Nama</th>
                  <th>Email</th>
                </tr>
              </tfoot>
              <tbody>
                {% for registrant in registrant %}
                	{% if registrant.arival %}
	                  <tr>
	                    <td>{{ registrant.idPeserta }}</td>
	                    <td>{{ registrant.namaDepan }} {{ registrant.namaBelakang }}</td>
	                    <td>{{ registrant.email }}</td>
	                  </tr>
	                {% else %}
	                {% endif %}
                {% endfor %}  
              </tbody>
            </table>
          </div>
        </div>
      </div> -->
</body>

<script src="{% static 'js/qrcode/jsqrcode-combined.js' %}"></script>
<script src="{% static 'js/qrcode/html5-qrcode.js' %}"></script>
<script>
function refreshTableArival() {
    $("#aribaTable").load(" #aribaTable > *");
    return false;
}

$(document).ready(function() {
	var flag = function(ticket_id) {
		var src = "{% static 'audio/beep.mp3' %}";
		var audio = new Audio(src);
		$.ajax({
	     	method: "POST",
	     	url: "{% url 'qr_admin:flag' %}",
	     	data: {
	     		'ticketId': ticket_id
	     	},
	     	success: function(data) {
	     		audio.play();
				if (data.redeemed) {
					$(".feedback").html('Ticket: ' + ticket_id + ' has been redeemed!');
				}
				else {
					$(".feedback").html('Sucess redeem Ticket: ' + ticket_id);
				}
	     	},
	     	error: function(error) {
	     		alert("An error occured");
	     		console.log(error);
	     	}
	     })
	}


	$("#scan").on('click', function() {
		$("code").html('Scanning');
		$('#qr').html5_qrcode(function(ticket_id){
		         $.ajax({
		         	method: "POST",
		         	url: "{% url 'qr_admin:validate' %}",
		         	data: {
		         		'ticketId': ticket_id
		         	},
		         	success: function(ticket) {
		         		if (ticket.exists) {
		         			flag(ticket_id);
		         		}
		         		else {
		         			alert("Invalid Ticket Id");
		         		}
		         	},
		         	error: function(error) {
		         		alert("An error occured");
		         		console.log(error);
		         	}
		         })
		    },
		    function(error){
		        //show read errors
		    }, function(videoError){
		        //the video stream could be opened
		    }
		);
		$("#scan").addClass('disabled');
		$("#stop").removeClass('disabled');
		$("#change").removeClass('disabled');
	});
	$("#stop").on('click', function() {
		$("#qr").html5_qrcode_stop();
		$("code").html('Start Scanning');
		$("#scan").removeClass('disabled');
		$("#stop").addClass('disabled');
		$("#change").addClass('disabled');
	});
	$("#change").on('click', function() {
		$("#qr").html5_qrcode_changeCamera();
		$("#scan").addClass('disabled');
		$("#stop").removeClass('disabled');
	});
});
	
</script>
{% endblock %}

templates/summary.html
{% extends "navbarAdmin.html" %}
{% load static %}
{% block content %}
<div class="card mb-3">
  <div class="card-header">
    <i class="fa fa-table"></i> Summary
  </div>
  <div class="card-body">
    <div><button id="refresh" onclick="refreshSummary()"><i class="fa fa-refresh"></i> Refresh</button></div>
    <hr>
    <h5>Ticket Count: {{ ticket_count}}</h5>
    <h5>Redeemed Ticket: {{ redeemed_ticket }}</h5>
  </div>
</div>
<script>
function refreshSummary() {
  location.reload();
}
</script>
{% endblock %}

templates/uploadData.html
{% extends "navbarAdmin.html" %}
{% load static %}
{% block content %}
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Upload Excel File</title>
</head>
<body>
	<div class="container" style="text-align: center">
		<form method="post" action="{% url 'qr_admin:uploadExcel' %}" enctype="multipart/form-data">
			{% csrf_token %}
			<label for="myfile">Select file:</label>
  			<input type="file" id="myFile" name="myFile"><br><br>
  			<input type="submit">
		</form>
	</div>
</body>

{% endblock %}